#ifndef LBB_COMMON_H
#define LBB_COMMON_H
#ifdef tyujrtyutyuteyu
#ifdef SOFT_DEBUG
#define DEBUG_PRINT
#ifndef NULL
#define NULL (0L)
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define printk printf
#define KERN_ERR "KERN_ERR: "
#define KERN_INFO "KERN_INF: "
#define KERN_WARNING "KERN_WARN: "
#define KERN_NOTICE "KERN_NOT: "
#define PrintLog(a,b,...)
#define kmalloc(x,y) (malloc(x))
#define kfree(x) (free(x))
#define x_spin_lock_init(x,y) {}
#define x_spin_lock(x) {if (x) {}}
#define x_spin_unlock(x) {if (x) {}}
#define x_rwlock_init(x,y) {}
#define x_write_lock(x) {if (x) {}}
#define x_write_unlock(x) {if (x) {}}
#define x_write_lock_irq(x) {if (x) {}}
#define x_write_unlock_irq(x) {if (x) {}}
#define x_read_lock_irq(x) {if (x) {}}
#define x_read_lock(x) {if (x) {}}
#define x_read_unlock(x) {if (x) {}}
#define x_read_unlock_irq(x) {if (x) {}}
#define atomic_read(x) (*x)
#define atomic_set(x,a) {*x=a;}
#define atomic_inc(x) {++(*x);}
#define atomic_dec(x) {--(*x);}
#define atomic_dec_and_test(x) (--(*x))
#define kmem_cache_create(a,b,c,d,e) ((void *)(b))
#define kmem_cache_destroy(x) {x=NULL;if (x) {}}
#else
#include <linux/types.h>
#ifndef DEBUG_SPIN_LOCK
#else
void debug_spin_lock_init(spinlock_t * x,const char * name);
void debug_spin_lock(spinlock_t * x,unsigned int info);
void debug_spin_unlock(spinlock_t * x);
void debug_spin_lock_irq(spinlock_t * x,unsigned int info);
void debug_spin_unlock_irq(spinlock_t * x);
int debug_spin_trylock(spinlock_t * x);
#define x_rwlock_init(x,y) rwlock_init(x)
#define x_write_lock(x) write_lock(x)
#define x_write_unlock(x) write_unlock(x)
#define x_read_lock(x) read_lock(x)
#define x_read_unlock(x) read_unlock(x)
#define x_spin_lock_init(x,y) debug_spin_lock_init(x,y)
#define x_spin_lock(x,y) debug_spin_lock(x,y)
#define x_spin_unlock(x) debug_spin_unlock(x)
#define x_spin_lock_irq(x,y) debug_spin_lock_irq(x,y)
#define x_spin_unlock_irq(x) debug_spin_unlock_irq(x)
#define x_spin_trylock(x) debug_spin_trylock(x)
#define x_spin_trylock(x) debug_spin_trylock(x)
#define x_rwlock_init(x,y) debug_rwlock_init(x,y)
#define x_write_lock(x) debug_write_lock(x)
#define x_write_unlock(x) debug_write_unlock(x)
#define x_read_lock(x) debug_read_lock(x)
#define x_read_unlock(x) debug_read_unlock(x)
#endif
#endif
#endif
#ifdef DEBUG_LBB_STACK
unsigned int debug_stack_print_info(char * buf);
void debug_stack_check(void);
#define STACK_CHECK {debug_stack_check();}
#else
#define STACK_CHECK
#define debug_stack_print_info(x) (0)
#endif
typedef unsigned long long uint64;
#define FILE_NAME_LEN (256)
#define BDEV_NAME_LEN (16)
#define ERR_SECT_NUM ((sector_t)(-1L))
#ifndef SECTOR_SHIFT
#define SECTOR_SHIFT (9)
#define SECTOR_SIZE (1 << SECTOR_SHIFT)
#endif
#define LBB_STAT_CATCH (0)
#define LBB_STAT_OFF (1)
#define LBB_STAT_STOP (2)
#define IS_SPACE(t) ((t==' ')||(t==0x09)||(t==0x0a)||(t==0x0d))
unsigned int get_module_version(void);
unsigned int get_module_info(char * buf);
void PrintLog(int level,const char * format,...);
void print_vect(const void * vect,int len,const char * add);
char * format_mem_size(unsigned long long size);
char * format_time_size(unsigned int second);
char * format_mtime_size(unsigned long msec);
char * format_swdt_print(unsigned long sbeg,unsigned long send);
char * print_version(unsigned long ver);
int check_ssdev_name(const char * name);
int check_dev_name(const char * name);
int check_file_name(const char * name);
int check_is_blockdev(const char * name);
int check_is_directory(const char * path);
struct block_device * bdev_get_bd_contains(struct block_device * bdev);
size_t bdev_get_start_sect(struct block_device * bdev);
size_t bdev_get_block_size(struct block_device * bdev);
sector_t bdev_get_nr_sects(struct block_device * bdev);
unsigned char calc_block2sect(size_t block_size,size_t sect_size);
#endif
