#ifndef LBB_ERRORS_H
#define LBB_ERRORS_H
#include <linux/errno.h>
const char * error_to_text(int errnum);
#define NO_ERR (0)
#define ERR_ZERO_POINTER (-100)
#define ERR_PARAMS (-EINVAL)
#define ERR_NO_MEMORY (-ENOMEM)
#define ERR_DEVICE_BUSY (-EBUSY)
#define ERR_ITEM_EXIST (-200)
#define ERR_ITEM_NOT_EXIST (-201)
#define ERR_BDEV_SIZE (-202)
#define ERR_NODE_AT_DISK (-300)
#define ERR_NODE_UNKNOWN (-301)
#define ERR_NODE_CNTR (-302)
#define ERR_NODE_ALLOC (-303)
#define ERR_NODE_NOT_EXIST (-304)
#define ERR_NODE_REALLOK (-305)
#define ERR_NO_STORE (-400)
#define ERR_STORE_IS_FULL (-401)
#define ERR_STORE_TOO_DEEP (-403)
#define ERR_STORE_TOO_BIG (-404)
#define ERR_STORE_OPEN_DEV (-405)
#define ERR_STORE_CREATE (-406)
#define ERR_STORE_NO_FILE (-407)
#define ERR_STORE_PATH (-408)
#define ERR_NO_MAP_TREE (-415)
#define ERR_DUPLICATE_NAME (-416)
#define ERR_NO_EMPTY_SLOT (-417)
#define ERR_NO_IMPLEMENTED (-501)
#define ERR_STATE_NOT_OFF (-502)
#define ERR_KOBJ_SYS (-503)
#define ERR_KOBJ_CREATE (-504)
#define ERR_KOBJ_FILE (-505)
#define ERR_CMD_UNKNOWN (-506)
#define ERR_CMD_NO_XDEV (-507)
#define ERR_CREATE_RD_BIO (-601)
#define ERR_CREATE_WR_BIO (-602)
#define ERR_ALLOC_PAGE (-603)
#define ERR_UNSTOP_DEV (-604)
#define ERR_IT_WORK_TIMEOUT (-700)
#define ERR_IT_READ_REQUEST (-701)
#define ERR_IT_WRITE_REQUEST (-702)
#define ERR_IT_ZERO_REQUEST (-703)
#define ERR_IT_COUNT_REQUEST (-704)
#define ERR_IT_UNKNOWN_STAT (-705)
#define ERR_IT_FROM_QUEUE (-706)
#define ERR_IT_CREATE (-707)
#define ERR_TOO_MANY_FILES (-800)
#define ERR_SNAPSHOT_OVERLAP (-801)
#define ERR_SNAPSHOT_OFF (-802)
#define ERR_BIO_POINTER (-860)
#define ERR_BIO_SPLIT (-861)
#define ERR_INTERNAL1 (-910)
#define ERR_INTERNAL2 (-911)
#define ERR_INTERNAL3 (-912)
#define ERR_INTERNAL4 (-913)
#define ERR_INTERNAL5 (-914)
#define ERR_CMD_BLOCK_NOT_USED (-6789)
#endif
