#ifndef LBB_BLOCK_STORE_H
#define LBB_BLOCK_STORE_H
typedef struct _lbb_block_store lbb_block_store;
int lbb_block_store_init(void);
void lbb_block_store_destroy(void);
lbb_block_store * lbb_block_store_open_bdev(char * dev_save,sector_t begin,sector_t end,unsigned char rl_to_sect,int * rcod);
lbb_block_store * lbb_block_store_open_file(char * file_path,sector_t size,unsigned int total_files,unsigned char rl_to_sect,int * rcod);
void lbb_block_store_close(lbb_block_store * store);
int lbb_block_store_resize(lbb_block_store * store,sector_t sect_beg,sector_t sect_end);
struct block_device * lbb_block_store_get_dev(lbb_block_store * store);
int lbb_block_store_status(lbb_block_store * store);
sector_t lbb_block_store_map(lbb_block_store * store,sector_t orig);
int lbb_block_store_check(lbb_block_store * store,sector_t orig_block);
int lbb_block_store_activate(lbb_block_store * store,sector_t b_save,sector_t b_orig);
sector_t lbb_block_store_allocate(lbb_block_store * store);
size_t lbb_block_store_get_map(lbb_block_store * store,char * bitmap,size_t offset,size_t size);
unsigned int lbb_block_store_get_total(lbb_block_store * store);
unsigned int lbb_block_store_get_busy(lbb_block_store * store);
unsigned int lbb_block_store_print_info(lbb_block_store * store,char * buf);
size_t lbb_block_store_table_read(lbb_block_store * store,char * table,size_t offset,size_t size);
unsigned int lbb_block_store_cmd_info(lbb_block_store * store,char * buf);
unsigned int lbb_block_store_get_mem(lbb_block_store * store);
#endif
