#include <linux/kthread.h>
#include <linux/wait.h>
#include <linux/kernel.h>
#include "lbb_block_store2.h"
#include "common.h"
#include "errors.h"
struct _lbb_block_store;
typedef struct _lbb_block_store lbb_block_store;
void lbb_block_store_thread_int(lbb_block_store * store);
struct task_struct * bs_thread=NULL;
wait_queue_head_t bs_head;
lbb_block_store * bs_req=NULL;
int lbb_block_store_request(void * store)
{
if (bs_req !=NULL) return-1;
bs_req=(lbb_block_store *)store;
wake_up(&bs_head);
return NO_ERR;
}
static int lbb_block_store_thread(void * data)
{
lbb_block_store * store;
PrintLog(0,KERN_NOTICE "Run Thread block store resize process\n");
set_user_nice(current,17);
while (!kthread_should_stop())
{
wait_event_interruptible(bs_head,kthread_should_stop() || (bs_req !=NULL));
store=bs_req;
bs_req=NULL;
lbb_block_store_thread_int(store);
}
bs_thread=NULL;
PrintLog(0,KERN_NOTICE "Exit Thread block store resize process\n");
return 0;
}
int lbb_block_store_thread_init(void)
{
bs_req=NULL;
init_waitqueue_head(&bs_head);
bs_thread=kthread_create(lbb_block_store_thread,NULL,"cblb.bstore");
if (IS_ERR_OR_NULL(bs_thread)) return-1;
wake_up_process(bs_thread);
return NO_ERR;
}
void lbb_block_store_thread_destroy(void)
{
if (bs_thread !=NULL) kthread_stop(bs_thread);
}
