#ifndef LBB_MAP_TREE_H
#define LBB_MAP_TREE_H
typedef struct _lbb_map_tree lbb_map_tree;
enum bit_set_mode
{
BM_SET=0,BM_OR=1,BM_AND=2,};
lbb_map_tree * lbb_map_tree_create(size_t map_size,unsigned int block_size,unsigned char default_value);
void lbb_map_tree_destroy(lbb_map_tree * map);
size_t lbb_map_tree_get_size(lbb_map_tree * map);
size_t lbb_map_tree_get_set(lbb_map_tree * map);
int lbb_map_check_status(lbb_map_tree * map,size_t index);
int lbb_map_check_opt(lbb_map_tree * map);
int lbb_map_set_range(lbb_map_tree * map,size_t offset,size_t size,unsigned char value,enum bit_set_mode mode);
int lbb_map_check_range(lbb_map_tree * map,size_t offset,size_t size,unsigned char value);
size_t lbb_map_set_status_map(lbb_map_tree * map,char * bitmap,size_t offset,size_t size,enum bit_set_mode mode);
size_t lbb_map_get_status_map(lbb_map_tree * map,char * bitmap,size_t offset,size_t size);
unsigned int lbb_bitmap_print_info(lbb_map_tree * map,char * buf);
unsigned long lbb_map_get_mem(lbb_map_tree * map);
#ifdef DEBUG_PRINT
void map_print_all(lbb_map_tree * map);
void map_print_tree(lbb_map_tree * map);
#endif
#endif
