#include <linux/module.h>
#include <linux/moduleparam.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/ctype.h>
#include "lbb_device.h"
#include "kernel_hook.h"
#include "lbb_cdev_debug.h"
#include "lbb_kernel.h"
#define LBB_VERSION "0.17 debug"
#define LBB_RELDATE "08.07.2019"
MODULE_LICENSE("GPL");
MODULE_AUTHOR("[@e56r71]");
MODULE_DESCRIPTION("CLBB snapshot driver");
MODULE_VERSION(LBB_VERSION);
unsigned long start_time;
unsigned int version=1;
int total=4;
module_param(total,int,0);
MODULE_PARM_DESC(total,"Number of devices to initialise (4)");
unsigned int get_module_version(void)
{
return version;
}
unsigned int get_module_info(char * buf)
{
unsigned int rcod=0;
rcod+=sprintf(buf+rcod,"Module: %s\n",KBUILD_MODNAME);
rcod+=sprintf(buf+rcod,"Version: %s\n",LBB_VERSION);
rcod+=sprintf(buf+rcod,"Date: %s\n",LBB_RELDATE);
rcod+=sprintf(buf+rcod,"Uptime: %s\n",format_time_size(get_xsecond()-start_time));
rcod+=sprintf(buf+rcod,"Mem used: %s",format_mem_size((unsigned long long)lbb_get_mem_used()));
return rcod;
}
static int __init module_start(void)
{
int rcod;
start_time=get_xsecond();
PrintLog(0,"****** LBB module init (total=%d). Ver %s (%s)\n",total,LBB_VERSION,LBB_RELDATE);
rcod=lbb_cdev_init();
if (rcod) goto exit;
rcod=lbb_register(total);
if (rcod) goto exit1;
rcod=init_hooks();
if (rcod) goto exit2;
return 0;
exit2:
lbb_unregister();
exit1:
lbb_cdev_exit();
exit:
return rcod;
}
static void __exit module_stop(void)
{
cleanup_hooks();
lbb_unregister();
lbb_cdev_exit();
printk("****** LBB module exit\n");
}
module_init(module_start);
module_exit(module_stop);
